/********************************************************************************************
 * Projekt:		FRITZ!Box AddOn																*
 * Version:		2.00.04																		*
 * Plattform:	XP/Vista/Windows 7/Windows 8 sowie MacOS/Linux (ohne XP-COM)				*
 *																							*
 * Modul:		Javascript fr Einstellungen des Firefox Addon								*
 * Autor:		Karsten																		*
 * Dateiname:	Einstellungen.js															*
 *																							*
 * 31.10.2012	Benutzername fr Single Sign On												*
 * 18.07.2012	erst Repeater-Modus dann IP													*
 * 14.07.2011	Repeater ohne XP-COM														*
 * 10.08.2010	C-Types Schnittstlle														*
********************************************************************************************/

//Checkbox-Wert
var sFritzBoxIp = "fritz.box";
var sFritzRepeaterIp = "fritz.repeater";
var benutzername = "";
var update = 0;
var repeaterStart = 0;
var downloadManager = null;

var FB_Addon2 = new FB_AddonPrototyp();
//var dlListener = new FB_AddonPrototypDLM();
function FB_Addon_LoadPrefs() {
   //alert("FB_Addon_LoadPrefs()");
	FB_Addon2.szInstance = "Einstellungen";
	//FB_Addon2.m_bDebug = true;
	FB_Addon2.init();
	
	var nodeKennwort = document.getElementById("kennwort");
	nodeKennwort.value = FB_Addon2.getPasswort();
	
	benutzername = FB_Addon2.getString("Benutzername");
	document.getElementById("Benutzername").value = benutzername;

	sFritzBoxIp = FB_Addon2.getString("FritzBoxIp");
	sFritzRepeaterIp = FB_Addon2.getString("FritzRepeaterIp");

	if( sFritzBoxIp.length > 0 )
	{
		if( sFritzBoxIp.indexOf( "http://" ) == 0 )
		{
			sFritzBoxIp = sFritzBoxIp.substring(7, sFritzBoxIp.length );
		}		
		document.getElementById("ipAdresse").value = sFritzBoxIp;
		/*if( sFritzBoxIp == "fritz.box" || sFritzBoxIp == "http://fritz.box" )
		{
			document.getElementById("groupAdresse").selectedIndex = 0;
			//document.getElementById("ipAdresse").disabled = true;
			sFritzBoxIp = "";
		}
		else
		{
			document.getElementById("ipAdresse").value = sFritzBoxIp;
			document.getElementById("groupAdresse").selectedIndex = 1;
		}*/
	}
	
	repeaterStart = FB_Addon2.get("Repeater");

	if( sFritzRepeaterIp.length > 0 )
	{
		if( sFritzRepeaterIp == "fritz.repeater" || sFritzRepeaterIp == "http://fritz.repeater" )
		{
			//MAC-OS: nur bei Start
			document.getElementById("ipAdresseRepeater").disabled = true;
			sFritzRepeaterIp = "";
			repeaterStart = 1;
		}
		else
		{
			repeaterStart = 2;
		}
	}
	else
	{	//MAC-OS: nur bei Start
		document.getElementById("ipAdresseRepeater").disabled = true;
	}
		
	//alert("Update " + update);
	document.getElementById("groupAdresseRepeater").selectedIndex = repeaterStart;

	var checkStatusBar = document.getElementById("ipStatusBar")

	if (checkStatusBar != null) {
		checkStatusBar.checked = FB_Addon2.bIpStatusBar;
	}

	//existieren diese Elemente
	update = FB_Addon2.get("Update");

	if (document.getElementById("updateMelden") != null) {
		if (update > 1) {
			document.getElementById("updateMelden").checked = true;

			if (update > 2) {
				document.getElementById("updateInstallieren").checked = true;
			}
		}
		onupdateMelden();
	}

	//Rufnummern
	var nodeAmt = document.getElementById("vorwahl");
		
	if( nodeAmt != null){
		nodeAmt.value = FB_Addon2.szNationalVorwahl;
		//alert(FB_Addon2.szNationalVorwahl);
	}

	var nodeMarkieren = document.getElementById("aktivieren");
	nodeMarkieren.checked = FB_Addon2.bTelNoMarkieren;

	DoCheckRepeater();
	//DANACH setzen!!!
	document.getElementById("ipAdresseRepeater").value = sFritzRepeaterIp;

}//Ende LoadPrefs()

function FB_Addon_OnOK()
{
	//alert("FB_Addon_OnOK()");
	try	{
		document.getElementById("ipAdresse").disabled = false;
		
		if( downloadManager != null ) {
			//downloadManager.removeListener( dlListener );
		}
		
		var sFritzBoxUrl = document.getElementById("ipAdresse").value;
		var sFritzRepeaterUrl = document.getElementById("ipAdresseRepeater").value;
		
		//neu ermitteln
		update = 1;
	 	if (document.getElementById("updateInstallieren").checked) {
			update = 3;
		}
		else if (document.getElementById("updateMelden").checked) {
			update = 2;
		}
		var checkStatusBar = document.getElementById("ipStatusBar")

		if (checkStatusBar != null) {
			FB_Addon2.bIpStatusBar = checkStatusBar.checked;
		}

		var nodeAmt = document.getElementById("vorwahl");
		//alert("nodeAmt " + nodeAmt.value);
		
		if( nodeAmt != null){
			FB_Addon2.szNationalVorwahl = nodeAmt.value;
		}

		var nodeMarkieren = document.getElementById("aktivieren");

		if (nodeMarkieren != null) {
			FB_Addon2.bTelNoMarkieren = nodeMarkieren.checked;
		}
		
		benutzername = document.getElementById("Benutzername").value;
		FB_Addon2.setString( "Benutzername", benutzername );
		
		var nodeKennwort = document.getElementById("kennwort");
		FB_Addon2.setPasswort(nodeKennwort.value);

		//alert("Update " + update);
		FB_Addon2.set("Update", update);
		FB_Addon2.speichereRegistry();
		//zuerst Repeater-Modus umschalten, dann IP setzen
		var repeater = document.getElementById("groupAdresseRepeater").selectedIndex;
		
		if( (repeater == 2) && (sFritzRepeaterUrl.length == 0) )
		{
			repeater = 1;//default
		}
		
		if( repeaterStart != repeater )
		{
			//alert( "changed from " + repeaterStart + " = > " + repeater );
			FB_Addon2.set("Repeater", repeater);
			
			//if( repeater == 3 ) repeater = 1;
			
			//if( (repeater == 0) || (repeater == 1) || (repeater == 2) )
			{
				if( FB_Addon2.xpCom != null ) 
				{
					FB_Addon2.xpCom.DoAction( 1, repeater, "change comments");//HOT ACTION
				}
			}
		}
		
		FB_Addon2.setString( "FritzBoxIp", sFritzBoxUrl );
		FB_Addon2.setString( "FritzRepeaterIp", sFritzRepeaterUrl );
	}
	catch (err) { alert(err); }

	FB_Addon2 = null;

	return true;
}//Ende OnOk()

function DoCheck()
{
	var sel = document.getElementById("groupAdresse").selectedIndex;
	//alert("DoCheck() " + sel);

	if( sel == 0 )
	{
		if(FB_Addon2.xpCom != null) {
			document.getElementById("ipAdresse").value = "";//Text muss auch manuell gelscht werden
		}
		else {
			document.getElementById("ipAdresse").value = "http://fritz.box";
			FB_Addon2.setString( "FritzBoxIp", "http://fritz.box");//MAC OS sonst wird nicht gespeichert
		}

		if(FB_Addon2.xpCom != null) {
			//v2 document.getElementById("ipAdresse").disabled = true;
		}
	}
	else {
		document.getElementById("ipAdresse").disabled = false;
	}
}

function DoCheckRepeater()
{
	var sel = document.getElementById("groupAdresseRepeater").selectedIndex;
	//alert("DoCheckRepeater() " + sel);
	
	if( sel == 0 )
	{
		//MAC-OS
		if( FB_Addon2.xpCom != null ) {
			document.getElementById("ipAdresseRepeater").disabled = true;
			FB_Addon2.setString( "FritzRepeaterIp", "");//MAC OS sonst wird nicht gespeichert
		}
		document.getElementById("ipAdresseRepeater").value = "";
	}
	else if( sel == 1 )
	{
		if(FB_Addon2.xpCom != null) {
			document.getElementById("ipAdresseRepeater").disabled = true;
			document.getElementById("ipAdresseRepeater").value = "";
		}
		else {
			document.getElementById("ipAdresseRepeater").value = "fritz.repeater";
			FB_Addon2.setString( "FritzRepeaterIp", "fritz.repeater");//MAC OS sonst wird nicht gespeichert
		}
	}
	else if( sel == 2 )
	{
		document.getElementById("ipAdresseRepeater").disabled = false;
		document.getElementById("ipAdresseRepeater").value = "";
	}
}

function FB_Addon_OnCancel()
{
	//alert("FB_Addon_OnCancel()");
	/*if( FB_Addon2.xpCom == null )
	{
		var sFritzBoxIp = document.getElementById("ipAdresse").value;
		
		if( sFritzBoxIp != sFritzBoxIpLoaded )
		{
			//alert("OnCancel2OnOk");
			var sConfirm = "Save changes?";
			//var sConfirm = &fb_add_on.prefs.optionUser;
			
			if( window.confirm(sConfirm) )
			{
				FB_Addon_OnOK();
			}
		}
	}*/
	return true;
}

function onupdateMelden() 
{
	//alert("onupdateMelden");
	var sel = document.getElementById("updateMelden").checked;
	
	update = 1;//Extrawurst fr alle Pinguine

	if (sel)
	{
		//alert("checked");
		document.getElementById("updateInstallieren").disabled = false;
		
		update = 2;
		
		if( document.getElementById("updateInstallieren").checked ) {
			update = 3;
		}
	}
	else {
		//alert("User");
		document.getElementById("updateInstallieren").checked = false;
		document.getElementById("updateInstallieren").disabled = true;
	}
	
	FB_Addon2.set("Update", update);
}
function FB_Addon_onRufnummernAktivieren() {
   var nodeMarkieren = document.getElementById("aktivieren");

	FB_Addon2.bTelNoMarkieren = nodeMarkieren.checked;
	FB_Addon2.setBool("TelNoMarkieren", FB_Addon2.bTelNoMarkieren);
	//alert("FB_Addon_onRufnummernAktivieren() = "+ FB_Addon2.get("TelNoMarkieren") );//debug
	
	if( nodeMarkieren.checked ) {
	   try {
			if( FB_Addon2.xpCom == null )
			{
				var pw = FB_Addon2.getPasswort();
				
				if( pw.length == 0 ) {
					var s = FB_Addon2.ResourceBundle.getString("FunktionNichtOS");
					//var s = window.arguments[0].inn.FunktionNichtOS;
					alert(s);
				}
			}
		}
		catch(err){alert(err);}            
	}
}